# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.component_carrier import ComponentCarrier  # noqa: F401,E501
from swagger_server import util


class ActiveFrequencyBand(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, afb_bandwidth: int=None, afb_central_frequency: int=None, afb_cc_list: List[ComponentCarrier]=None):  # noqa: E501
        """ActiveFrequencyBand - a model defined in Swagger

        :param afb_bandwidth: The afb_bandwidth of this ActiveFrequencyBand.  # noqa: E501
        :type afb_bandwidth: int
        :param afb_central_frequency: The afb_central_frequency of this ActiveFrequencyBand.  # noqa: E501
        :type afb_central_frequency: int
        :param afb_cc_list: The afb_cc_list of this ActiveFrequencyBand.  # noqa: E501
        :type afb_cc_list: List[ComponentCarrier]
        """
        self.swagger_types = {
            'afb_bandwidth': int,
            'afb_central_frequency': int,
            'afb_cc_list': List[ComponentCarrier]
        }

        self.attribute_map = {
            'afb_bandwidth': 'afb-bandwidth',
            'afb_central_frequency': 'afb-central-frequency',
            'afb_cc_list': 'afb-cc-list'
        }
        self._afb_bandwidth = afb_bandwidth
        self._afb_central_frequency = afb_central_frequency
        self._afb_cc_list = afb_cc_list

    @classmethod
    def from_dict(cls, dikt) -> 'ActiveFrequencyBand':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The active-frequency-band of this ActiveFrequencyBand.  # noqa: E501
        :rtype: ActiveFrequencyBand
        """
        return util.deserialize_model(dikt, cls)

    @property
    def afb_bandwidth(self) -> int:
        """Gets the afb_bandwidth of this ActiveFrequencyBand.


        :return: The afb_bandwidth of this ActiveFrequencyBand.
        :rtype: int
        """
        return self._afb_bandwidth

    @afb_bandwidth.setter
    def afb_bandwidth(self, afb_bandwidth: int):
        """Sets the afb_bandwidth of this ActiveFrequencyBand.


        :param afb_bandwidth: The afb_bandwidth of this ActiveFrequencyBand.
        :type afb_bandwidth: int
        """

        self._afb_bandwidth = afb_bandwidth

    @property
    def afb_central_frequency(self) -> int:
        """Gets the afb_central_frequency of this ActiveFrequencyBand.


        :return: The afb_central_frequency of this ActiveFrequencyBand.
        :rtype: int
        """
        return self._afb_central_frequency

    @afb_central_frequency.setter
    def afb_central_frequency(self, afb_central_frequency: int):
        """Sets the afb_central_frequency of this ActiveFrequencyBand.


        :param afb_central_frequency: The afb_central_frequency of this ActiveFrequencyBand.
        :type afb_central_frequency: int
        """

        self._afb_central_frequency = afb_central_frequency

    @property
    def afb_cc_list(self) -> List[ComponentCarrier]:
        """Gets the afb_cc_list of this ActiveFrequencyBand.


        :return: The afb_cc_list of this ActiveFrequencyBand.
        :rtype: List[ComponentCarrier]
        """
        return self._afb_cc_list

    @afb_cc_list.setter
    def afb_cc_list(self, afb_cc_list: List[ComponentCarrier]):
        """Sets the afb_cc_list of this ActiveFrequencyBand.


        :param afb_cc_list: The afb_cc_list of this ActiveFrequencyBand.
        :type afb_cc_list: List[ComponentCarrier]
        """

        self._afb_cc_list = afb_cc_list
